#!/usr/bin/env python3

# This script creates stack.yaml, hyperion-config/src/Config.hs and build.sh
# See details in Readme.md or call ./configure.py --help
#
# NB: DO NOT EDIT stack.yaml directly, edit create_stack_yaml_text() instead!
#
# NB: do not call 'stack build', always call build.sh instead:
# it will update stack.yaml and then call 'stack build'
#
# stack.yaml should contain 'use-external-hostname: true' for Expanse HPC,
# but 'use-external-hostname: false' for Caltech HPC.
# Thus, we have to generate it dynamically.

import argparse
import datetime
import os
import stat


def generated_header() -> str:
    return f'''# DO NOT EDIT, changes will be lost!
# This file has been generated by {os.path.abspath(__file__)}
# {datetime.datetime.now()}'''


def create_stack_yaml_text(use_external_hostname: str) -> str:
    return f'''{generated_header()}
flags:
  cryptonite:
    use_target_attributes: false
  hyperion:
    use-external-hostname: {use_external_hostname}
extra-include-dirs:
- /home/dsd/include
- /home/dssimmon/include
extra-lib-dirs:
- /home/dsd/lib
- /home/dssimmon/lib
- /home/pkravchuk/local/lib
- /home/fas/poland/rse23/lib
packages:
- .
- hyperion-config
extra-deps:
- git: https://github.com/davidsd/combinat.git
  commit: a9b9faafec5144f4828a0e26179b022952847ea5
- compact-word-vectors-0.2.0.2
- distributed-static-0.3.9@sha256:f5e781867eddec660cb3b39805c849e3f096b7da245d43a07d8529e3c92b3a27
- hgmp-0.1.2.1
- network-transport-tcp-0.8.1
- poly-0.5.1.0
- git: https://github.com/davidsd/vector-sized.git
  commit: f4808449581a829097a68a05739b16ef9c98b77a
- git: https://github.com/davidsd/long-double.git
  commit: 2014ac17911b1eda6f3cede5c335d974687d69c7
- numeric-limits-0.1.0.0@sha256:214bb53112bff315e42c0e9efa4a89e2cc2e9914e6232d923b596f29f9b1afe6,456
- git: https://github.com/haskell-distributed/distributed-process.git
  commit: f45c9d986edfb79669c54c646501b9448fc800e8
- git: https://github.com/haskell-distributed/distributed-process-systest.git
  commit: d43a6ee475b1ea2d3c5edcf460517a948eba7a78
- git: https://github.com/davidsd/distributed-process-async.git
  commit: bab06c5989db8dc32765c9b6c1795c020fa0ecf9
- git: https://github.com/davidsd/matrix-static.git
  commit: fdf02eab4b01391f7f530c4a22b366b9d2c8de41
- git: https://gitlab.com/pkravchuk/binaryhash.git
  commit: 2f65a2d472fccbd90636783c8a85ef553f8f9ea8
- git: https://gitlab.com/davidsd/hyperion-static.git
  commit: 26d55bfa4c6019558ff05b97b29bff9990db31ca
- git: https://github.com/davidsd/hyperion.git
  commit: 8877e0de862bb1f07889086c8e1a8160c6528d94
- git: https://gitlab.com/davidsd/quadratic-net.git
  commit: 1dfc0857f18cbee9b4e192af0bbeaa00c5e619b3
- git: https://gitlab.com/davidsd/sdpb-haskell.git
  commit: db579a21fc377ba12115cba8fb6e52271197ad28
- git: https://github.com/davidsd/rounded.git
  commit: d48b770c85c9b545ba0586de03b2791b4ee80f95
- git: https://gitlab.com/davidsd/hyperion-bootstrap.git
  commit: 5e51a5100168aa904bad11283bb5cd9f5dc22b40
- git: https://gitlab.com/pkravchuk/blocks-4d-haskell.git
  commit: 7f98f500360183c36f15eda960d61b4adc51af31
- git: https://gitlab.com/davidsd/eigen-rounded.git
  commit: b1434833b415808d6c7053498593678739ed1ef2
- git: https://gitlab.com/davidsd/bootstrap-math.git
  commit: ab7917429341c5225b45ba8f00cf1ce3d8a0d9f6
- git: https://gitlab.com/davidsd/bootstrap-build.git
  commit: 3675361eb8b4f16e83375785659c9b6dff9383f3
- git: https://gitlab.com/davidsd/bootstrap-bounds.git
  commit: 011d8c547f1ac8cdecddeedf1b99f95335f24a31
- git: https://gitlab.com/davidsd/blocks-core.git
  commit: 8394885cd32e2d3b152b33bc438efc59d5b03d60
- git: https://gitlab.com/davidsd/scalar-blocks.git
  commit: 01e08574aefd8e2e33124b551056ac16d1f71c34
- git: https://gitlab.com/davidsd/blocks-3d.git
  commit: 199433bedfaec39adcfc989ebb6d70611696b6a6
- git: https://gitlab.com/davidsd/scalars-3d.git
  commit: 51faebbfcbc05a468659ce468a66a88fe19205ac
resolver: nightly-2023-05-02
arch: x86_64
'''


def create_build_sh_text(args) -> str:
    return f'''#!/bin/sh

{generated_header()}

set -euo pipefail

# update stack.yaml
./configure.py --config-dir {args.config_dir} --use-external-hostname {args.use_external_hostname}

echo stack build $@
stack build $@
'''


def write_stack_yaml(use_external_hostname: str) -> None:
    print(
        f'Generating stack.yaml with use-external-hostname={use_external_hostname}'
    )
    with open('stack.yaml', 'w') as f:
        f.write(create_stack_yaml_text(use_external_hostname))


def set_config(config_dir: str) -> None:
    print(f"Setting up hyperion config from '{config_dir}'")
    source_config_hs = os.path.join(config_dir, 'Config.hs')
    if not os.path.exists(source_config_hs):
        raise FileNotFoundError(source_config_hs)

    target_dir = 'hyperion-config/src'
    os.makedirs(target_dir, exist_ok=True)

    target_config_hs = os.path.join(target_dir, 'Config.hs')
    if os.path.exists(target_config_hs):
        os.remove(target_config_hs)

    curdir = os.path.abspath(os.curdir)
    os.chdir(target_dir)
    src = os.path.relpath(source_config_hs, target_dir)
    print(f"Creating symlink in '{target_dir}': src='{src}', dst='Config.hs'")
    os.symlink(src=src, dst='Config.hs')
    os.chdir(curdir)


def write_build_sh(args) -> None:
    print('Generating build.sh')
    with open('build.sh', 'w') as f:
        f.write(create_build_sh_text(args))

    # chmod u+x build.sh
    mode = os.stat('build.sh').st_mode
    os.chmod('build.sh', mode | stat.S_IEXEC)


def configure():
    parser = argparse.ArgumentParser(
        description=
        """Generates 'stack.yaml' and creates symlink to 'CONFIG_DIR/Config.hs'.
Also creates 'build.sh' script, which calls 'configure.py' with given arguments and then calls 'stack build'.
""")
    parser.add_argument(
        '-c',
        '--config-dir',
        dest='config_dir',
        required=True,
        help=
        'Directory with Config.hs and scripts like blocks_3d.sh, e.g. hyperion-config/caltech-hpc-dsd'
    )
    parser.add_argument(
        '--use-external-hostname',
        dest='use_external_hostname',
        choices=['false', 'true'],
        default='false',
        help=
        'Sets flags/hyperions/use-external-hostname when generating stack.yaml. '
        'Should be true for Expanse HPC, false for Caltech HPC.')
    args = parser.parse_args()

    write_stack_yaml(args.use_external_hostname)
    set_config(args.config_dir)
    write_build_sh(args)
    print('Configuration finished successfully.')


if __name__ == '__main__':
    configure()
